package com.base.scanqr.ui.email

import androidx.activity.addCallback
import androidx.core.view.updatePadding
import androidx.lifecycle.ViewModelProvider
import com.base.scanqr.R
import com.base.scanqr.ads.AdsMgr
import com.base.scanqr.ads.AdsShowCallBack
import com.base.scanqr.base.BaseActivity
import com.base.scanqr.bean.EmailUIBean
import com.base.scanqr.bean.EmailUIBean.Companion.createEmailQrString
import com.base.scanqr.bean.FunctionUIBean.Companion.KEY_EMAIL
import com.base.scanqr.databinding.ActivityEmailCodeBinding
import com.base.scanqr.ui.vm.QrViewModel
import com.base.scanqr.ui.widget.InputNameDialog.showInputNameDialog
import com.base.scanqr.utils.BarUtils
import com.base.scanqr.utils.BitmapUtils.saveBitmapToFile
import com.base.scanqr.utils.ClipboardUtils.copyText
import com.base.scanqr.utils.IntentUtils.intentSendEmail
import com.base.scanqr.utils.IntentUtils.intentShareImage
import com.base.scanqr.utils.LogEx
import com.base.scanqr.utils.QRCodeUtils.generateQRCode
import com.base.scanqr.utils.SpJsonUtils
import com.base.scanqr.utils.ToastUtils.toast
import com.google.gson.Gson
import java.io.File

class EmailCodeActivity : BaseActivity<ActivityEmailCodeBinding>(ActivityEmailCodeBinding::inflate) {

    private var email = EmailUIBean()
    private var tempImagePath: String = ""
    private var qrString: String = ""

    private val viewModel by lazy(LazyThreadSafetyMode.NONE) {
        ViewModelProvider(this)[QrViewModel::class.java]
    }

    override fun onResumeOneShoot() {
        super.onResumeOneShoot()
        val flag = changeLanguage()
        if (flag) return

        AdsMgr.showBanner(binding.flBanner, false)
    }

    override fun initView() {
        super.initView()
        binding.clTop.updatePadding(top = BarUtils.getStatusBarHeight())
        AdsMgr.showNative(binding.flAd, R.layout.layout_admob_item)

        val data = intent.extras?.getString("data")
        email = Gson().fromJson(data, EmailUIBean::class.java)

        binding.tvAddress.text = email.address
        binding.tvSubject.text = email.subject
        binding.tvMessage.text = email.message

        Thread {
            qrString = createEmailQrString(email)
            val bitmap = generateQRCode(qrString, 735, 735, 5)
            runOnUiThread {
                binding.ivQr.setImageBitmap(bitmap)
                val file = File(cacheDir, System.currentTimeMillis().toString() + ".jpg")
                bitmap?.let {
                    val flag = saveBitmapToFile(it, file.absolutePath)
                    LogEx.logDebug(TAG, "flag=$flag tempImage=${file.absolutePath}")
                    if (flag) {
                        tempImagePath = file.absolutePath
                    }
                }
                if (email.needCreate) {
                    email.needCreate = false
                    SpJsonUtils.addJsonBean<EmailUIBean>(KEY_EMAIL, email)
                }
            }
        }.start()

    }

    override fun initListener() {
        super.initListener()

        onBackPressedDispatcher.addCallback {
            AdsMgr.showInsert(this@EmailCodeActivity, false, object : AdsShowCallBack() {
                override fun close(where: Int) {
                    finishToMainTop()
                }

                override fun failed(where: Int) {
                    finishToMainTop()
                }

                override fun googleFailed(where: Int) {
                    finishToMainTop()
                }
            })
        }
        binding.flBack.setOnClickListener {
            onBackPressedDispatcher.onBackPressed()
        }

        binding.llShare.setOnClickListener {
            val intent = intentShareImage(this, tempImagePath)
            runCatching {
                startActivity(intent)
            }
        }
        binding.llPdf.setOnClickListener {
            toast("没实现")
        }
        binding.llDownload.setOnClickListener {
            kotlin.runCatching {
                val newName = File(tempImagePath).name
                showInputNameDialog(newName) { name ->
                    viewModel.copyFileToDownloads(this, name, tempImagePath)
                }
            }
        }
        binding.llCopy.setOnClickListener {
            copyText(TAG, qrString)
            toast("Copied to clipboard", true)
        }
        binding.flSearch.setOnClickListener {
            val intent = intentSendEmail(email)
            try {
                startActivity(intent)
            } catch (e: Exception) {
                toast("No application was found to handle the email request", true)
            }
        }
    }
}